searchNodes=[{"doc":"Elixir interface to Linux input event devices","ref":"InputEvent.html","title":"InputEvent","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.See Supervisor.","ref":"InputEvent.html#child_spec/1","title":"InputEvent.child_spec/1","type":"function"},{"doc":"Scan the system for input devices and return information on each one.","ref":"InputEvent.html#enumerate/0","title":"InputEvent.enumerate/0","type":"function"},{"doc":"Return information about this input event device","ref":"InputEvent.html#info/1","title":"InputEvent.info/1","type":"function"},{"doc":"Start a GenServer that reports events from the specified input event device","ref":"InputEvent.html#start_link/1","title":"InputEvent.start_link/1","type":"function"},{"doc":"Stop the InputEvent GenServer.","ref":"InputEvent.html#stop/1","title":"InputEvent.stop/1","type":"function"},{"doc":"Information about a input event file","ref":"InputEvent.Info.html","title":"InputEvent.Info","type":"module"},{"doc":"Helper function for decoding raw report information from the port driver.","ref":"InputEvent.Info.html#decode_report_info/2","title":"InputEvent.Info.decode_report_info/2","type":"function"},{"doc":"","ref":"InputEvent.Info.html#t:t/0","title":"InputEvent.Info.t/0","type":"type"},{"doc":"InputEventElixir interface to Linux input event devices. Using input_event, you canFind out what keyboards, joysticks, mice, touchscreens, etc. are connectedGet information on what kinds of events they can produceGet decoded events sent to youThis library is intended for use with Nerves. If you're running a desktop Linux distribution, this can still work, but you'll likely want to use a higher level API for receiving events.","ref":"readme.html","title":"InputEvent","type":"extras"},{"doc":"InputEvent can be used to monitor /dev/input/event* devices and report decoded data to the parent process.Start by looking for the device you want to monitor:iex&gt; InputEvent.enumerate [ {&quot;/dev/input/event0&quot;, %InputEvent.Info{ bus: 0, input_event_version: &quot;1.0.1&quot;, name: &quot;FT5406 memory based driver&quot;, product: 0, report_info: [ ev_abs: [ abs_x: %{flat: 0, fuzz: 0, max: 800, min: 0, resolution: 0, value: 0}, abs_y: %{flat: 0, fuzz: 0, max: 480, min: 0, resolution: 0, value: 0}, abs_mt_slot: %{ flat: 0, fuzz: 0, max: 9, min: 0, resolution: 0, value: 0 }, abs_mt_position_x: %{ flat: 0, fuzz: 0, max: 800, min: 0, resolution: 0, value: 0 }, abs_mt_position_y: %{ flat: 0, fuzz: 0, max: 480, min: 0, resolution: 0, value: 0 }, abs_mt_tracking_id: %{ flat: 0, fuzz: 0, max: 65535, min: 0, resolution: 0, value: 0 } ], ev_key: [:btn_touch] ], vendor: 0, version: 0 }} ]There's a touchscreen at /dev/input/event0, so let's open it:iex&gt; InputEvent.start_link(&quot;/dev/input/event0&quot;) {:ok, #PID&lt;0.197.0&gt;}Touch the screen to testiex&gt; flush {:input_event, &quot;/dev/input/event0&quot;, [ {:ev_abs, :abs_mt_tracking_id, 1}, {:ev_abs, :abs_mt_position_x, 350}, {:ev_abs, :abs_mt_position_y, 119}, {:ev_key, :btn_touch, 1}, {:ev_abs, :abs_x, 350}, {:ev_abs, :abs_y, 119} ]} {:input_event, &quot;/dev/input/event0&quot;, [ {:ev_abs, :abs_mt_position_x, 352}, {:ev_abs, :abs_mt_position_y, 122}, {:ev_abs, :abs_x, 352}, {:ev_abs, :abs_y, 122} ]} {:input_event, &quot;/dev/input/event0&quot;, [{:ev_abs, :abs_mt_tracking_id, -1}, {:ev_key, :btn_touch, 0}]} {:input_event, &quot;/dev/input/event0&quot;, [ {:ev_abs, :abs_mt_tracking_id, 2}, {:ev_abs, :abs_mt_position_x, 361}, {:ev_abs, :abs_mt_position_y, 361}, {:ev_abs, :abs_mt_slot, 1}, {:ev_abs, :abs_mt_tracking_id, 3}, {:ev_abs, :abs_mt_position_x, 425}, {:ev_abs, :abs_mt_position_y, 139}, {:ev_key, :btn_touch, 1}, {:ev_abs, :abs_x, 361}, {:ev_abs, :abs_y, 361} ]} {:input_event, &quot;/dev/input/event0&quot;, [{:ev_abs, :abs_mt_position_y, 142}]} {:input_event, &quot;/dev/input/event0&quot;, [ {:ev_abs, :abs_mt_slot, 0}, {:ev_abs, :abs_mt_position_y, 363}, {:ev_abs, :abs_mt_slot, 1}, {:ev_abs, :abs_mt_position_x, 427}, {:ev_abs, :abs_mt_position_y, 147}, {:ev_abs, :abs_y, 363} ]} {:input_event, &quot;/dev/input/event0&quot;, [{:ev_abs, :abs_mt_position_x, 428}, {:ev_abs, :abs_mt_position_y, 149}]} {:input_event, &quot;/dev/input/event0&quot;, [ {:ev_abs, :abs_mt_slot, 0}, {:ev_abs, :abs_mt_tracking_id, -1}, {:ev_abs, :abs_mt_slot, 1}, {:ev_abs, :abs_mt_tracking_id, -1}, {:ev_key, :btn_touch, 0} ]} :ok","ref":"readme.html#usage","title":"InputEvent - Usage","type":"extras"},{"doc":"Enumerating attached devices can be really helpful in figuring out what kind of messages that you'll be sent. Here are other examples:Keyboard {&quot;/dev/input/event3&quot;, %InputEvent.Info{ bus: 3, input_event_version: &quot;1.0.1&quot;, name: &quot;Logitech K520&quot;, product: 8209, report_info: [ ev_rep: [250, :rep_delay, 33, :rep_delay], ev_led: [:led_numl, :led_capsl, :led_scrolll, :led_compose, :led_kana], ev_msc: [:msc_scan], ev_abs: [ abs_volume: %{ flat: 0, fuzz: 0, max: 652, min: 1, resolution: 0, value: 0 } ], ev_rel: [:rel_hwheel], ev_key: [:key_esc, :key_1, :key_2, :key_3, :key_4, :key_5, :key_6, :key_7, :key_8, :key_9, :key_0, :key_minus, :key_equal, :key_backspace, :key_tab, :key_q, :key_w, :key_e, :key_r, :key_t, :key_y, :key_u, :key_i, :key_o, :key_p, :key_leftbrace, :key_rightbrace, ...] ], vendor: 1133, version: 273 }}Events from a keyboard look like:{:input_event, &quot;/dev/input/event3&quot;, [{:ev_msc, :msc_scan, 458761}, {:ev_key, :key_f, 1}]} {:input_event, &quot;/dev/input/event3&quot;, [{:ev_msc, :msc_scan, 458761}, {:ev_key, :key_f, 0}]}The 1 and 0 indicate key down and key up.Mouse {&quot;/dev/input/event2&quot;, %InputEvent.Info{ bus: 3, input_event_version: &quot;1.0.1&quot;, name: &quot;Logitech M310&quot;, product: 4132, report_info: [ ev_msc: [:msc_scan], ev_rel: [:rel_x, :rel_y, :rel_hwheel, :rel_wheel], ev_key: [:btn_left, :btn_right, :btn_middle, :btn_side, :btn_extra, :btn_forward, :btn_back, :btn_task, 280, 281, 282, 283, 284, 285, 286, 287] ], vendor: 1133, version: 273 }}Events from a mouse look like:{:input_event, &quot;/dev/input/event2&quot;, [{:ev_rel, :rel_x, 12}]} {:input_event, &quot;/dev/input/event2&quot;, [{:ev_rel, :rel_x, 14}, {:ev_rel, :rel_y, -1}]}Notice that if there's no movement in an axis that you won't get an update for that axis.Joystick {&quot;/dev/input/event15&quot;, %InputEvent.Info{ bus: 3, input_event_version: &quot;1.0.1&quot;, name: &quot;Microsoft X-Box 360 pad&quot;, product: 654, report_info: [ ev_ff: &#39;PQXYZ`&#39;, ev_abs: [ abs_x: %{ flat: 128, fuzz: 16, max: 32767, min: -32768, resolution: 0, value: 0 }, abs_y: %{ flat: 128, fuzz: 16, max: 32767, min: -32768, resolution: 0, value: 0 }, abs_z: %{flat: 0, fuzz: 0, max: 255, min: 0, resolution: 0, value: 0}, abs_rx: %{ flat: 128, fuzz: 16, max: 32767, min: -32768, resolution: 0, value: 0 }, abs_ry: %{ flat: 128, fuzz: 16, max: 32767, min: -32768, resolution: 0, value: 0 }, abs_rz: %{flat: 0, fuzz: 0, max: 255, min: 0, resolution: 0, value: 0}, abs_hat0x: %{ flat: 0, fuzz: 0, max: 1, min: -1, resolution: 0, value: 0 }, abs_hat0y: %{ flat: 0, fuzz: 0, max: 1, min: -1, resolution: 0, value: 0 } ], ev_key: [:btn_a, :btn_b, :btn_x, :btn_y, :btn_tl, :btn_tr, :btn_select, :btn_start, :btn_mode, :btn_thumbl, :btn_thumbr] ], vendor: 1118, version: 272 }}Power button {&quot;/dev/input/event0&quot;, %InputEvent.Info{ bus: 25, input_event_version: &quot;1.0.1&quot;, name: &quot;Power Button&quot;, product: 1, report_info: [ev_key: [:key_power]], vendor: 0, version: 0 }}The power button input device works just like a one-button keyboard.","ref":"readme.html#examples","title":"InputEvent - Examples","type":"extras"}]